#include <Arduino.h>
#include <ESP32Servo.h>
#include <NewPing.h>

//defines 
#define MAX_DISTANCE_LEFT 15
#define PING_INTERVAL 1000
#define TRIGGER_PIN_LEFT 18
#define ECHO_PIN_LEFT 19
#define MAX_DISTANCE_RIGHT 15
#define TRIGGER_PIN_RIGHT 13
#define ECHO_PIN_RIGHT 12
#define servo_left 23
#define servo_right 10 

//variables
unsigned long startMillis;
unsigned long currentMillis_LEFT;
unsigned long previousPingTime_LEFT = 0;
float distance_LEFT;
unsigned long currentMillis_RIGHT;
unsigned long previousPingTime_RIGHT = 0;
float distance_RIGHT;
int pos;

Servo servo_RIGHT; //defines right servo
Servo servo_LEFT; //defines left servo
NewPing sonar_LEFT(TRIGGER_PIN_LEFT, ECHO_PIN_LEFT, MAX_DISTANCE_LEFT); //setup 2 sonars
NewPing sonar_RIGHT(TRIGGER_PIN_RIGHT, ECHO_PIN_RIGHT, MAX_DISTANCE_RIGHT); //setup 2 sonars

void setup() {
  Serial.begin(9600);
  startMillis = millis(); //starting millis
  servo_LEFT.attach(servo_left); //PINport 
  servo_RIGHT.attach(servo_right); //PINport
}

void read_distance_LEFT() { //checks in it's time to ping
  currentMillis_LEFT = millis(); //get current number of milliseconds since the code began
  if (currentMillis_LEFT - previousPingTime_LEFT >= PING_INTERVAL) {
    previousPingTime_LEFT = currentMillis_LEFT; //updates the previous ping time
    distance_LEFT = sonar_LEFT.ping_cm(); //get the distance in cm
    Serial.println(distance_LEFT);
  }
}

void read_distance_RIGHT() { //checks in it's time to ping
  currentMillis_RIGHT = millis(); //get current number of milliseconds since the code began
  if (currentMillis_RIGHT - previousPingTime_RIGHT >= PING_INTERVAL) {
    previousPingTime_RIGHT = currentMillis_RIGHT; //updates the previous ping time
    distance_RIGHT = sonar_RIGHT.ping_cm(); //get the distance in cm
    //Serial.println(distance_LEFT);
  }
}

void move_LEFT_floors() {
  if(distance_LEFT <= 15 && distance_LEFT >= 10) {
    //servo_LEFT.write(180);
    //Serial.println("moving servo");
    //Legg til delay? evt i loop koden
    for (pos = 0; pos <= 180; pos += 10) { // goes from 0 degrees to 180 degrees
      // in steps of 1 degree
      servo_LEFT.write(pos);              // tell servo to go to position in variable 'pos'
      delay(15);                       // waits 15 ms for the servo to reach the position
    }
    for (pos = 180; pos >= 0; pos -= 10) { // goes from 180 degrees to 0 degrees
      servo_LEFT.write(pos);              // tell servo to go to position in variable 'pos'
      delay(15);                       // waits 15 ms for the servo to reach the position
    }
    
  }
}

void move_RIGHT_floors() {
  if(distance_RIGHT <= 5 && distance_RIGHT >= 0) {
    servo_RIGHT.write(180);
    //delay to move
  }
}


void loop() {
  read_distance_LEFT();
  move_LEFT_floors();
  //read_distance_RIGHT();
}
